from trios.classifiers.isi import ISI, SKClassifier
from trios.feature_extractors import RAWBitFeatureExtractor, RAWFeatureExtractor
import trios
import numpy as np

# import scikit-learn models

import trios.shortcuts.persistence as p

if __name__ == '__main__':
    images = trios.Imageset.read('jung/level1.set')
    test = trios.Imageset.read('images/test.set')
    win = np.ones((9, 7), np.uint8)
    
    # ISI requires features coded in the bits of an int32
    op_isi = trios.WOperator(win, ISI, RAWBitFeatureExtractor)
    print('Training...')
    op_isi.train(images)
    print('Error', op_isi.eval(test))

    # train WOperator using logistic regression
    op_lr = trios.WOperator(win, ..., ...)
    print('Training')
    op_lr.train(images)
    print('Error(LogReg)', op_lr.eval(test))


    # train operator using Decision Tree
    op_dt = trios.WOperator(win, ..., ...)
    print('Training')
    op_dt.train(images)
    print('Error(LogReg)', op_dt.eval(test))

