from trios.classifiers import SKClassifier
from sklearn.tree import DecisionTreeClassifier
from trios.feature_extractors import RAWFeatureExtractor, CombinationPattern
import trios
import numpy as np

import trios.shortcuts.persistence as p
import trios.shortcuts.window as w

if __name__ == '__main__':
    images = trios.Imageset.read('jung/level1.set')
    images2 = trios.Imageset.read('jung/level2.set')
    test = trios.Imageset.read('jung/test.set')
    domain = np.ones((7, 7), np.uint8)
    
    
    # train operators using basic shapes

    comb = CombinationPattern(...., procs=5) # pass the trained operators as argument
    wop2 = trios.WOperator(comb.window, SKClassifier(DecisionTreeClassifier()), comb) 
    print('Training 2nd level')
    wop2.train(images)
    
    # save trained operator 
    p.save_gzip(op, 'dt-tl-jung.op')
    # and load it later
    #op2 = p.load_gzip('dt-tl-jung.op')
    
    # load image and apply operator. Second argument is application mask.
    img= p.load_image('images/jung-1a.png')
    print('Applying to image jung-1a.png')
    out = wop2.apply(img, img)
    p.save_image(out, 'out-isi-jung-1a.png')
    
    print('Error', wop2.eval(test, procs=1))
